using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace ForeignKeyGrid {
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form {
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1() {
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(8, 8);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(560, 256);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(576, 273);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() {
			Application.Run(new Form1());
		}

		DataSet dataSet;
		private void Form1_Load(object sender, System.EventArgs e) {
			try{
				DataTable tableMain = new DataTable();
				tableMain.TableName = "TableMain";
				DataTable tableForeign = new DataTable();
				tableForeign.TableName = "TableForeign";
			
				dataSet = new DataSet();
				dataSet.Tables.Add(tableMain);
				dataSet.Tables.Add(tableForeign);

				tableMain.Columns.Add("id", typeof( System.Int32 ));
				tableMain.Columns.Add("quantity", typeof( System.String));
				tableForeign.Columns.Add( "id", typeof( System.Int32 ));
				tableForeign.Columns.Add( "itemName", typeof(System.String));
				tableForeign.Columns.Add( "itemDescription", typeof(System.String));
				tableForeign.PrimaryKey = new DataColumn[] { tableForeign.Columns["id"] };
				

				DataColumn[] col = new DataColumn[1];
				col[0] = tableMain.Columns["id"];
				tableMain.PrimaryKey = col;
				DataRow rowMain = tableMain.NewRow();
				rowMain["id"] = 1;
				rowMain["quantity"] = 100;
				tableMain.Rows.Add( rowMain );

				DataRow rowMain2 = tableMain.NewRow();
				rowMain2["id"] = 2;
				rowMain2["quantity"] = 250;
				tableMain.Rows.Add( rowMain2);

				DataRow rowForeign = tableForeign.NewRow();
				rowForeign["id"] = 1;
				rowForeign["itemName"] = "baseball";
				rowForeign["itemDescription"] = "round ball";
				tableForeign.Rows.Add(rowForeign);

				DataRow rowForeign2 = tableForeign.NewRow();
				rowForeign2["id"] = 2;
				rowForeign2["itemName"] = "basketball";
				rowForeign2["itemDescription"] = "big round ball";
				tableForeign.Rows.Add(rowForeign2);

				this.gridGroupingControl1.DataSource = tableMain;

				this.gridGroupingControl1.ShowGroupDropArea = true; 
				this.gridGroupingControl1.FilterRuntimeProperties = true; // don't show all properties in PropertyGrid 

				// Add these lines for foreign key reference 
				this.gridGroupingControl1.TableDescriptor.QueryValue += new FieldValueEventHandler(TableDescriptor_QueryValue); 
				this.gridGroupingControl1.TableDescriptor.SaveValue += new FieldValueEventHandler(TableDescriptor_SaveValue); 

				GridRelationDescriptor rd = new GridRelationDescriptor();
				rd.ChildTableName = "TableForeign"; 
				rd.RelationKeys.Add("id", "id"); 
				rd.RelationKind = RelationKind.ForeignKeyReference; 

				this.gridGroupingControl1.TableDescriptor.Relations.Add(rd); 
			} catch (Exception ex){
				System.Console.WriteLine(ex.StackTrace + " " + ex.Message);
			}


		}
		private void TableDescriptor_QueryValue(object sender, FieldValueEventArgs e) { 
			string relatedTablePrefix = "TableForeign."; 
			if (e.Field.Name.StartsWith(relatedTablePrefix)) { 
				string column = e.Field.Name.Substring(relatedTablePrefix.Length); 
				object id = e.Record.GetValue("id"); 
				DataRow row = dataSet.Tables["tableForeign"].Rows.Find(id); 
				if (row != null)
					e.Value = row[column]; 
			} 
		} 

		private void TableDescriptor_SaveValue(object sender, FieldValueEventArgs e) { 
			string relatedTablePrefix = "TableForeign."; 
			if (e.Field.Name.StartsWith(relatedTablePrefix)) { 
				string column = e.Field.Name.Substring(relatedTablePrefix.Length); 
				object id = e.Record.GetValue("id"); 
				DataRow row = dataSet.Tables["tableForeign"].Rows.Find(id);
				if (row != null)
					row[column] = e.Value; 
			} 
		} 

	}
}
